#version 140

#ifdef GL_ES
precision highp float;
#endif

out vec4 fragColor;

uniform sampler2D tex;

in vec2 uvOut;

void main()
{
	float kernel[7] = float[7](
		0.106595,
		0.140367,
		0.165569,
		0.174938,
		0.165569,
		0.140367,
		0.106595
	);

	float tsize = 1.0/float(textureSize(tex, 0).x);

	float sum = 0.0;

	for (int i=-3; i<=3; i++)
		sum += kernel[3+i]*texture(tex, uvOut + vec2(float(i)*tsize, 0.0)).r;

	fragColor.xyz = vec3(sum);
	fragColor.w = 1.0;
}
