#version 140

#include "../include/constants.vert"
#include "../include/clip_plane.vert"

in vec3 pos;

// this is for point lights only, so positions will do
// w = uniform scale
uniform vec4 light_pos_world[MAX_LIGHT_INSTANCES];

uniform mat4 proj;

flat out int instanceID;

void main()
{
	instanceID = gl_InstanceID;
	vec4 lps = light_pos_world[gl_InstanceID];
	vec3 vpos = lps.xyz + pos*lps.w;

	clip_vertex(vpos);

	gl_Position = proj * vec4(vpos, 1.0);
}
