#version 140

// simple textured with color
#ifdef GL_ES
precision highp float;
#endif

#include "include/fragData.frag"
#include "include/clip_plane.frag"

// texture uvs
in vec2 uvOut;
// color
in vec4 colOut;

// diffuse color
uniform sampler2D tex;

#ifndef NO_NORM_BUFFER
in vec3 worldNormOut;
#endif

void main(void)
{
	clip_pixel();

	vec4 diffuse = texture(tex, uvOut);

	if (diffuse.w < 0.5)
		discard;

#ifndef NO_SPEC_BUFFER
	fragData3 = vec4(0.0);
#endif

#ifndef NO_NORM_BUFFER
	fragData2.xyz = worldNormOut;
#endif

	fragData1 = diffuse;
	fragColor = diffuse * colOut;
}
