#version 140

#include "include/quat_vec.vert"
#include "include/clip_plane.vert"

in vec3 pos;
in vec3 norm;
in vec2 uv;
in vec2 uv2;

uniform vec4 model_trans;
uniform vec4 model_quat;
uniform mat4 proj;

out vec2 uvOut;
out vec2 uvOut2;
out vec3 worldNormOut;

void main(void)
{
	vec3 vpos = pos;
	vpos = quat_vec(model_quat, vpos) * model_trans.w +
		model_trans.xyz;

	clip_vertex(vpos);

	gl_Position = proj * vec4(vpos, 1.0);
	uvOut = uv;
	uvOut2 = uv2;

	worldNormOut = norm;
}
