#version 140

// old-school lightmapping
#ifdef GL_ES
precision highp float;
#endif

#include "include/fragColor.frag"
#include "include/clip_plane.frag"

//#define USE_GAMMA

#ifdef WORLD_DYNAMIC_LIGHT
in vec3 light_dir;
uniform vec4 light_color;
#endif

// texture uvs
in vec2 uvOut;
// lightmap uvs
in vec2 uvOut2;
// color (alpha_blend)
in vec4 colOut;

// diffuse color
uniform sampler2D tex;
// secondary diffuse color
uniform sampler2D tex2;
// base color lightmap
uniform sampler2D tex3;

void main(void)
{
	clip_pixel();

	mat4 dither = mat4(
	0.0, 8.0, 2.0, 10.0,
	12.0, 4.0, 14.0, 6.0,
	3.0, 11.0, 1.0, 9.0,
	15.0, 7.0, 13.0, 5.0) / (16.0*128.0);

	vec4 b0 = unpack_lightmap(texture(tex3, uvOut2));

	// new: testing RGBM max 5 (ugly banding still but that's mostly because my rendertarget is 8 bit) + interpolation errors!
	//b0.xyz *= vec3(b0.w*6.0);

#ifdef USE_GAMMA
	// unpack lightmap
	b0.xyz = pow(b0.xyz, vec3(2.2));
#endif

	vec4 diffuse;
	vec4 final;

	diffuse = mix(texture(tex, uvOut), texture(tex2, uvOut), colOut.a);

#ifdef USE_GAMMA
	diffuse.xyz = pow(diffuse.xyz, vec3(2.2));
#endif

	// use diffuse alpha for potential transparency
	final.xyz = b0.xyz;

	// fake ambient
	//final.xyz = max(final.xyz, vec3(0.2));

	final.w = diffuse.w;

	// 2x overbright
	final.xyz *= diffuse.xyz * 2.0;

	// dither!
	//ivec2 iv = ivec2(gl_FragCoord.x, gl_FragCoord.y);
	//final.xyz += vec3(dither[iv.y & 3][iv.x & 3]);


#ifdef USE_GAMMA
	final.xyz = pow(final.xyz, vec3(1.0/2.2));
#endif

	fragColor = final;
}
