#version 140

#include "include/quat_vec.vert"
#include "include/clip_plane.vert"

in vec3 pos;
in vec2 uv;
in vec2 uv2;
in vec4 color;
in vec3 norm;

uniform mat4 proj;
uniform vec4 model_trans;
uniform vec4 model_quat;

out vec2 uvOut;
out vec2 uvOut2;
out vec4 colOut;

#ifdef WORLD_DYNAMIC_LIGHT
uniform float light_radius;
uniform vec3 light_pos;
out vec3 light_dir;
#endif

void main(void)
{
	vec3 vpos = pos;
	vpos = quat_vec(model_quat, vpos) * model_trans.w +
		model_trans.xyz;

	clip_vertex(vpos);

	gl_Position = proj * vec4(vpos, 1.0);
	uvOut = uv;
	uvOut2 = uv2;
	colOut = color;

#	ifdef WORLD_DYNAMIC_LIGHT
	light_dir = (pos - light_pos)/light_radius;
#	endif
}
