#version 140

// old-school lightmapping
#ifdef GL_ES
precision highp float;
#endif

#include "include/fragColor.frag"
#include "include/clip_plane.frag"

// texture uvs
in vec2 uvOut;
// lightmap uvs
in vec2 uvOut2;

// diffuse color
uniform sampler2D tex;
// base color lightmap
uniform sampler2D tex2;

// normal
uniform sampler2D tex3;

// depth buffer texture
//uniform sampler2D tex5;

uniform float animTime0;
uniform float animTime1;

uniform vec4 color;

uniform vec4 rcp_resolution;

void main(void)
{
	clip_pixel();

	vec4 b0 = unpack_lightmap(texture(tex2, uvOut2));

	//animTime1 = 0.001;

	vec4 dudv = texture(tex3, vec2(0.5 + uvOut.x + animTime1, uvOut.y + animTime1));
	dudv *= 2.0;
	dudv -= 1.0;

	vec4 dudv2 = texture(tex3, vec2(0.75+uvOut.x + animTime1, uvOut.y - animTime1));
	dudv2 *= 2.0;
	dudv2 -= 1.0;

	//dudv = max(dudv, dudv2);
	dudv *= dudv2;

	dudv *= 0.75;

	vec4 diffuse;
	vec4 final;

	diffuse = texture(tex, uvOut + dudv.xy);
	diffuse *= color;

	// use diffuse alpha for potential transparency
	final.xyz = b0.xyz;
	final.w = diffuse.w;

	// 2x overbright
	final.xyz *= diffuse.xyz * 2.0;

	fragColor = final;
}
