#version 140

#include "include/quat_vec.vert"
#include "include/clip_plane.vert"

in vec3 pos;
in vec2 uv;
in vec2 uv2;
in vec3 norm;

uniform mat4 proj;
uniform vec4 model_trans;
uniform vec4 model_quat;
uniform mat4 view;

uniform float animTime2;

// TODO: use uniform buffers, really...
uniform vec3 world_camera_position;

out vec2 uvOut;
out vec2 uvOut2;

out vec3 worldNormOut;
out vec3 worldDirOut;

#ifdef USE_TRANSPARENT_LIGHTS
out vec3 viewPosOut;
out vec3 viewNormOut;
#endif

void main(void)
{
	vec3 vpos = pos;
	vpos = quat_vec(model_quat, vpos) * model_trans.w +
		model_trans.xyz;

	clip_vertex(vpos);

	gl_Position = proj * vec4(vpos, 1.0);

	uvOut = uv;
	uvOut2 = uv2;
	uvOut.y += animTime2;
	worldNormOut = quat_vec(model_quat, norm);
	worldDirOut = vpos.xyz - world_camera_position;
#ifdef USE_TRANSPARENT_LIGHTS
	viewPosOut = (view * vec4(vpos, 1.0)).xyz;
	viewNormOut = (view * vec4(worldNormOut, 0.0)).xyz;
#endif
}
