#version 140

#include "../include/constants.vert"
#include "../include/quat_vec.vert"

in vec3 pos;
in vec2 uv;

uniform vec4 model_trans[MAX_MODEL_INSTANCES];
uniform vec4 model_quat[MAX_MODEL_INSTANCES];
uniform mat4 proj;

out vec2 uvOut;

void main(void)
{
	vec3 vpos = quat_vec(model_quat[gl_InstanceID], pos) * model_trans[gl_InstanceID].w +
		model_trans[gl_InstanceID].xyz;

	gl_Position = proj * vec4(vpos, 1.0);
	uvOut = uv;
}
