#version 140

#include "include/quat_vec.vert"
#include "include/clip_plane.vert"

in vec3 pos;
in vec2 uv;

uniform vec4 model_trans;
uniform vec4 model_quat;
uniform mat4 proj;

out vec2 uvOut;
out vec2 uvShift;
out vec2 uvShift2;
out vec2 uvShift3;

uniform float animTime0;
uniform float animTime1;
uniform float animTime2;

void main(void)
{
	vec3 vpos = pos;
	vpos = quat_vec(model_quat, vpos) * model_trans.w +
		model_trans.xyz;

	clip_vertex(vpos);

	gl_Position = proj * vec4(vpos, 1.0);
	uvOut = uv;
	uvShift.x = animTime0;
	uvShift.y = animTime0;
	uvShift2.x = animTime1;
	uvShift2.y = animTime1;
	uvShift3.x = animTime2;
	uvShift3.y = animTime2;
}
