#version 140

// simple textured with color
#ifdef GL_ES
precision highp float;
#endif

#include "include/fragData.frag"
#include "include/clip_plane.frag"

// texture uvs
in vec2 uvOut;
// color
in vec4 colOut;
// world normal
in vec3 normOut;

#ifndef NO_TEXTURE
// diffuse color
uniform sampler2D tex;
#endif

void main(void)
{
	clip_pixel();

#ifndef NO_TEXTURE
	vec4 diffuse = texture(tex, uvOut);
#else
	vec4 diffuse = vec4(1.0);
#endif

	fragColor = diffuse * colOut;

#ifndef NO_SPEC_BUFFER
	fragData3 = vec4(0.0);
#endif

#ifndef NO_NORM_BUFFER
	fragData2.xyz = normOut;
#endif
	fragData1 = diffuse;

}
