#version 140

#include "include/clip_plane.vert"
#include "include/srgb.frag"

in vec3 pos;
in vec2 uv;
in vec2 uv2;
in vec4 color;

uniform mat4 proj;

out vec2 uvOut;
out vec4 colOut;
out vec3 normOut;

void main(void)
{
	gl_Position = proj * vec4(pos, 1.0);
	clip_vertex(pos);
	uvOut = uv;

	// decode worldspace normal
	vec3 normal;
	normal.x = uv2.x;
	normal.y = uv2.y;
	normal.z = color.w;

	normOut = normal;

	// assume linear already
	colOut = /*srgb_to_linear*/(color) * 2.0;
	colOut.a = 1.0;
}
