#version 140

#ifdef GL_ES
precision highp float;
#endif

in vec2 uvOut;
in vec4 colOut;
uniform sampler2D tex;

out vec4 fragColor;

uniform vec2 msOfs;
uniform float sdfOfs;

uniform vec4 textColor;
uniform vec4 outlineColor;

vec4 SampleTex(vec2 coord)
{
	vec4 res = texture2D(tex, coord);
	vec4 outl = outlineColor;
	outl.w *= float(res.w > sdfOfs);
	return mix(colOut, outl, float(res.w < 0.5) );
}

void main(void)
{
	vec2 c = uvOut;
	vec4 res = SampleTex(c)*1.0;
	res += SampleTex(c - msOfs );
	res += SampleTex(c + vec2(msOfs.x, -msOfs.y) );
	res += SampleTex(c + vec2(-msOfs.x, msOfs.y) );
	res += SampleTex(c + msOfs);
	res *= (1.0/5.0);

	fragColor = res;
}
